	.nomlist
	.list

LEVEL	= $202B
OPTION1	= $20DE
OPTION2	= $20DF

KEITH_HEIGHT = $19 ;$19 gives enough jumping distance in almost all levels
RRAIN 	= 0

	.zp
	.bss
;--- CODE area ----------
	.code
	.bank 0
	.incbin "in-wat.pce"
;-------------------------
	.bank 0
	.org $E122	;29 01 0A, loads $2B for sprite CHR selection
	jsr	Return_Level_Bit0

	.org $E41F	;0A 26 6E - lots of palette indirection up to here
	jsr	Choose_SPR_Palette

	.org $E57F	;same
	jsr	Return_Level_Bit0

;	.org $E76B      ;Backwards Rainbow Logic (?)
;	.dw $4631	;Rainbow logic all KC's?

;-------------------------
	.bank 1

	.org $4FBF	;C9 12 - Keith's Jumping Height
	cmp #KEITH_HEIGHT

	.org $5117 ;(JSR $D185) Keith missing platform checking?
	jmp	Check_Platform_Keith

	.org $5137
	jmp	Check_Platform_KeithPt2

	IF (RRAIN=0) ;Reverse rainbow logic differs too.
	.org $5DB0
        TST  #$0C, <$3F
	ENDIF

	IF (RRAIN=1)
	.org $5DB0	;Reverse rainbow logic differs too.
	jmp	Reverse_Rainbow_1
	.org $5DFC
	LDA  <$88
	STA  $3741
	LDA  <$89
	STA  $3742
	ENDIF


	.org $5F3A	;missing JSR and skipping code!
	jmp	Check_Rainbow_Nova
	nop
;-------------------------
	.bank 2
	.org $6A76	;(JSR  $D3D8) NOVA code is missing door checking
	jsr	Check_Door_Nova
;-------------------------
	.bank 6
	.org $CC55	;0A 26 6E - Room Exiting SPR palette indirection
	jsr	Choose_SPR_Palette ;NOW WORKS WHEN YOU EXIT A SHOP!

;=========== MY CODE ===============
	.bank 0
	.org $FF00


Return_Level_Bit0:
	and	#1
	beq	.chk_nova_stage
.chk_keith_stage:
	lda     OPTION1		;If 0, default NOVA suit!
	bra	.end		;If 1, normal "KEITH"
.chk_nova_stage:
	lda     OPTION2		;Rules are as above
.end:
	and	#1
	asl	a
	rts
;----
Check_Door_Nova:
	JSR  $D509	;Check door in this sub
	JMP  $D3D8	;Then return via this JMP
;----
Check_Rainbow_Nova:
	JSR  $D7C9	;This is extra: Rainbow Warp Check
	BCC  .continue
	RTS
.continue:
	STZ  <$53
	STZ  <$56
	jmp  $5F3E
;--------------------------
Check_Platform_Keith:
	JSR  $D185
	LDA  $3799
	PHA
	jsr $D5FA	;Perhaps platform-checking code?
	jmp $511A 	;Jump back part 1!

Check_Platform_KeithPt2:
	PLA
	ORA  $3799
	STA  $3799
	jmp  $513A	;Jump back part 2!

;--------------------
Choose_SPR_Palette:	;The game bulk-loads BG and SPR palettes.
			;We need to choose the right one for our current guy.
	cmp	#$1A
	beq	.was_nova_pal
	cmp	#$1B
	bne	.not_either_pal
.was_keith_pal:
.was_nova_pal:
	lda	<LEVEL  ;Get stage num
	jsr	Return_Level_Bit0 ;Return one of two variables
	lsr	a	;back into bit 0. 0=NOVA, 1=KEITH
	ora	#$1A	;1A = NOVA, 1B=KEITH

.not_either_pal:
	asl	a
	rol	<$6E
	rts

;-------------------------------------
;Goddamn reverse rainbow logic
	IF (RRAIN=1)
Reverse_Rainbow_1:
	LDA  #$42
	STA  <$88
	STZ  <$89
	TST  #$0C, <$3F
	BEQ  .rainbow_end
	STZ  <$86
	STZ  <$87
	TST  #$04, <$3F
	BEQ  .rainbow_end
	CLC
	LDA  <$88
	ADC  #$A0
	STA  <$88
	LDA  <$89
	ADC  #$00
	STA  <$89
.rainbow_end:
	jmp	$5DB9
	ENDIF
;======================================
; A little extra text.
Add_More_Text:
	jsr	$918E       ;Print function.
	lda	#LOW(MYTEXT)
	sta     <$D0
	lda	#HIGH(MYTEXT)
	sta     <$D1
	jmp	$919A		;Jump into the middle of the print subroutine
;----------------------

MYTEXT: .dw $0700	;VRAM Address!
	.include "Wataru-Cred.asm"
	.db $FF,$FF

;======================================
	.include "Wataru-DebugMenu.asm"

